Index: /trunk/include/VBox/pdmdev.h
===================================================================
--- /trunk/include/VBox/pdmdev.h	(revision 12975)
+++ /trunk/include/VBox/pdmdev.h	(revision 12976)
@@ -232,15 +232,5 @@
 typedef FNPDMDEVINITCOMPLETE *PFNPDMDEVINITCOMPLETE;
 
-/**
- * APIC version.
- */
-typedef enum
-{
-    APIC_NONE = 0,
-    APIC_XAPIC,
-    APIC_X2APIC,
-    /** The usual 32-bit paranoia. */
-    PDMAPICVERSION_32BIT_HACK = 0x7fffffff
-} PDMAPICVERSION;
+
 
 /** PDM Device Registration Structure,
@@ -1054,4 +1044,22 @@
 
 /**
+ * APIC version argument for pfnChangeFeature.
+ */
+typedef enum PDMAPICVERSION
+{
+    /** Invalid 0 entry. */
+    PDMAPICVERSION_INVALID = 0,
+    /** No APIC. */
+    PDMAPICVERSION_NONE,
+    /** Standard APIC (X86_CPUID_FEATURE_EDX_APIC). */
+    PDMAPICVERSION_APIC,
+    /** Intel X2APIC (X86_CPUID_FEATURE_ECX_X2APIC). */
+    PDMAPICVERSION_X2APIC,
+    /** The usual 32-bit paranoia. */
+    PDMAPICVERSION_32BIT_HACK = 0x7fffffff
+} PDMAPICVERSION;
+
+
+/**
  * APIC RC helpers.
  */
@@ -1081,7 +1089,7 @@
      *
      * @param   pDevIns         Device instance of the APIC.
-     * @param   version         Supported APIC version.
-     */
-    DECLRCCALLBACKMEMBER(void, pfnChangeFeature,(PPDMDEVINS pDevIns, PDMAPICVERSION version));
+     * @param   enmVersion      Supported APIC version.
+     */
+    DECLRCCALLBACKMEMBER(void, pfnChangeFeature,(PPDMDEVINS pDevIns, PDMAPICVERSION enmVersion));
 
     /**
@@ -1149,7 +1157,7 @@
      *
      * @param   pDevIns         Device instance of the APIC.
-     * @param   version         Supported APIC version.
-     */
-    DECLR0CALLBACKMEMBER(void, pfnChangeFeature,(PPDMDEVINS pDevIns, PDMAPICVERSION version));
+     * @param   enmVersion      Supported APIC version.
+     */
+    DECLR0CALLBACKMEMBER(void, pfnChangeFeature,(PPDMDEVINS pDevIns, PDMAPICVERSION enmVersion));
 
     /**
@@ -1216,7 +1224,7 @@
      *
      * @param   pDevIns         Device instance of the APIC.
-     * @param   version         Supported APIC version.
-     */
-    DECLR3CALLBACKMEMBER(void, pfnChangeFeature,(PPDMDEVINS pDevIns, PDMAPICVERSION version));
+     * @param   enmVersion      Supported APIC version.
+     */
+    DECLR3CALLBACKMEMBER(void, pfnChangeFeature,(PPDMDEVINS pDevIns, PDMAPICVERSION enmVersion));
 
     /**
Index: /trunk/src/VBox/Devices/PC/DevAPIC.cpp
===================================================================
--- /trunk/src/VBox/Devices/PC/DevAPIC.cpp	(revision 12975)
+++ /trunk/src/VBox/Devices/PC/DevAPIC.cpp	(revision 12976)
@@ -481,5 +481,5 @@
         /* Clear any pending APIC interrupt action flag. */
         cpuClearInterrupt(dev, s);
-        dev->CTX_SUFF(pApicHlp)->pfnChangeFeature(pDevIns, APIC_NONE);
+        dev->CTX_SUFF(pApicHlp)->pfnChangeFeature(pDevIns, PDMAPICVERSION_NONE);
     }
     /* APIC_UNLOCK(dev); */
@@ -1832,5 +1832,5 @@
     /* Reset should re-enable the APIC. */
     s->apicbase = 0xfee00000 | MSR_IA32_APICBASE_BSP | MSR_IA32_APICBASE_ENABLE;
-    dev->pApicHlpR3->pfnChangeFeature(dev->pDevInsR3, APIC_XAPIC);
+    dev->pApicHlpR3->pfnChangeFeature(dev->pDevInsR3, PDMAPICVERSION_APIC);
     /* Clear any pending APIC interrupt action flag. */
     cpuClearInterrupt(dev, s);
@@ -2011,5 +2011,5 @@
         {
             LogRel(("Activating Local APIC\n"));
-            pThis->pApicHlpR3->pfnChangeFeature(pDevIns, APIC_XAPIC);
+            pThis->pApicHlpR3->pfnChangeFeature(pDevIns, PDMAPICVERSION_APIC);
         }
     }
Index: /trunk/src/VBox/VMM/PDMDevice.cpp
===================================================================
--- /trunk/src/VBox/VMM/PDMDevice.cpp	(revision 12975)
+++ /trunk/src/VBox/VMM/PDMDevice.cpp	(revision 12976)
@@ -236,5 +236,5 @@
 static DECLCALLBACK(void) pdmR3ApicHlp_SetInterruptFF(PPDMDEVINS pDevIns, VMCPUID idCpu);
 static DECLCALLBACK(void) pdmR3ApicHlp_ClearInterruptFF(PPDMDEVINS pDevIns, VMCPUID idCpu);
-static DECLCALLBACK(void) pdmR3ApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION version);
+static DECLCALLBACK(void) pdmR3ApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION enmVersion);
 static DECLCALLBACK(int) pdmR3ApicHlp_Lock(PPDMDEVINS pDevIns, int rc);
 static DECLCALLBACK(void) pdmR3ApicHlp_Unlock(PPDMDEVINS pDevIns);
@@ -4171,25 +4171,25 @@
 
 /** @copydoc PDMAPICHLPR3::pfnChangeFeature */
-static DECLCALLBACK(void) pdmR3ApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION version)
+static DECLCALLBACK(void) pdmR3ApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION enmVersion)
 {
     PDMDEV_ASSERT_DEVINS(pDevIns);
     LogFlow(("pdmR3ApicHlp_ChangeFeature: caller='%s'/%d: version=%d\n",
-             pDevIns->pDevReg->szDeviceName, pDevIns->iInstance, (int)version));
-    switch (version)
-    {
-        case APIC_NONE:
+             pDevIns->pDevReg->szDeviceName, pDevIns->iInstance, (int)enmVersion));
+    switch (enmVersion)
+    {
+        case PDMAPICVERSION_NONE:
             CPUMClearGuestCpuIdFeature(pDevIns->Internal.s.pVMR3, CPUMCPUIDFEATURE_APIC);
             CPUMClearGuestCpuIdFeature(pDevIns->Internal.s.pVMR3, CPUMCPUIDFEATURE_X2APIC);
             break;
-        case APIC_XAPIC:
+        case PDMAPICVERSION_APIC:
             CPUMSetGuestCpuIdFeature(pDevIns->Internal.s.pVMR3, CPUMCPUIDFEATURE_APIC);
             CPUMClearGuestCpuIdFeature(pDevIns->Internal.s.pVMR3, CPUMCPUIDFEATURE_X2APIC);
             break;
-        case APIC_X2APIC:
+        case PDMAPICVERSION_X2APIC:
             CPUMSetGuestCpuIdFeature(pDevIns->Internal.s.pVMR3, CPUMCPUIDFEATURE_X2APIC);
             CPUMSetGuestCpuIdFeature(pDevIns->Internal.s.pVMR3, CPUMCPUIDFEATURE_APIC);
             break;
         default:
-            AssertMsgFailed(("Unknown APIC version: %d\n", (int)version));
+            AssertMsgFailed(("Unknown APIC version: %d\n", (int)enmVersion));
     }
 }
Index: /trunk/src/VBox/VMM/VMMGC/PDMGCDevice.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMGC/PDMGCDevice.cpp	(revision 12975)
+++ /trunk/src/VBox/VMM/VMMGC/PDMGCDevice.cpp	(revision 12976)
@@ -101,5 +101,5 @@
 static DECLCALLBACK(void) pdmRCApicHlp_SetInterruptFF(PPDMDEVINS pDevIns, VMCPUID idCpu);
 static DECLCALLBACK(void) pdmRCApicHlp_ClearInterruptFF(PPDMDEVINS pDevIns, VMCPUID idCpu);
-static DECLCALLBACK(void) pdmRCApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION version);
+static DECLCALLBACK(void) pdmRCApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION enmVersion);
 static DECLCALLBACK(int) pdmRCApicHlp_Lock(PPDMDEVINS pDevIns, int rc);
 static DECLCALLBACK(void) pdmRCApicHlp_Unlock(PPDMDEVINS pDevIns);
@@ -415,24 +415,24 @@
 
 /** @copydoc PDMAPICHLPRC::pfnChangeFeature */
-static DECLCALLBACK(void) pdmRCApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION version)
-{
-    PDMDEV_ASSERT_DEVINS(pDevIns);
-    LogFlow(("pdmRCApicHlp_ChangeFeature: caller=%p/%d: version=%d\n", pDevIns, pDevIns->iInstance, version));
-    switch (version)
+static DECLCALLBACK(void) pdmRCApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION enmVersion)
+{
+    PDMDEV_ASSERT_DEVINS(pDevIns);
+    LogFlow(("pdmRCApicHlp_ChangeFeature: caller=%p/%d: version=%d\n", pDevIns, pDevIns->iInstance, (int)enmVersion));
+    switch (enmVersion)
     {
-        case APIC_NONE:
+        case PDMAPICVERSION_NONE:
             CPUMClearGuestCpuIdFeature(pDevIns->Internal.s.pVMRC, CPUMCPUIDFEATURE_APIC);
             CPUMClearGuestCpuIdFeature(pDevIns->Internal.s.pVMRC, CPUMCPUIDFEATURE_X2APIC);
             break;
-        case APIC_XAPIC:
+        case PDMAPICVERSION_APIC:
             CPUMSetGuestCpuIdFeature(pDevIns->Internal.s.pVMRC, CPUMCPUIDFEATURE_APIC);
             CPUMClearGuestCpuIdFeature(pDevIns->Internal.s.pVMRC, CPUMCPUIDFEATURE_X2APIC);
             break;
-        case APIC_X2APIC:
+        case PDMAPICVERSION_X2APIC:
             CPUMSetGuestCpuIdFeature(pDevIns->Internal.s.pVMRC, CPUMCPUIDFEATURE_X2APIC);
             CPUMSetGuestCpuIdFeature(pDevIns->Internal.s.pVMRC, CPUMCPUIDFEATURE_APIC);
             break;
         default:
-            AssertMsgFailed(("Unknown APIC version: %d\n", (int)version));
+            AssertMsgFailed(("Unknown APIC version: %d\n", (int)enmVersion));
     }
 }
Index: /trunk/src/VBox/VMM/VMMR0/PDMR0Device.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR0/PDMR0Device.cpp	(revision 12975)
+++ /trunk/src/VBox/VMM/VMMR0/PDMR0Device.cpp	(revision 12976)
@@ -101,5 +101,5 @@
 static DECLCALLBACK(void) pdmR0ApicHlp_SetInterruptFF(PPDMDEVINS pDevIns, VMCPUID idCpu);
 static DECLCALLBACK(void) pdmR0ApicHlp_ClearInterruptFF(PPDMDEVINS pDevIns, VMCPUID idCpu);
-static DECLCALLBACK(void) pdmR0ApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION version);
+static DECLCALLBACK(void) pdmR0ApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION enmVersion);
 static DECLCALLBACK(int) pdmR0ApicHlp_Lock(PPDMDEVINS pDevIns, int rc);
 static DECLCALLBACK(void) pdmR0ApicHlp_Unlock(PPDMDEVINS pDevIns);
@@ -420,24 +420,24 @@
 
 /** @copydoc PDMAPICHLPR0::pfnChangeFeature */
-static DECLCALLBACK(void) pdmR0ApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION version)
-{
-    PDMDEV_ASSERT_DEVINS(pDevIns);
-    LogFlow(("pdmR0ApicHlp_ChangeFeature: caller=%p/%d: version=%d\n", pDevIns, pDevIns->iInstance, version));
-    switch (version)
+static DECLCALLBACK(void) pdmR0ApicHlp_ChangeFeature(PPDMDEVINS pDevIns, PDMAPICVERSION enmVersion)
+{
+    PDMDEV_ASSERT_DEVINS(pDevIns);
+    LogFlow(("pdmR0ApicHlp_ChangeFeature: caller=%p/%d: version=%d\n", pDevIns, pDevIns->iInstance, (int)enmVersion));
+    switch (enmVersion)
     {
-        case APIC_NONE:
+        case PDMAPICVERSION_NONE:
             CPUMClearGuestCpuIdFeature(pDevIns->Internal.s.pVMR0, CPUMCPUIDFEATURE_APIC);
             CPUMClearGuestCpuIdFeature(pDevIns->Internal.s.pVMR0, CPUMCPUIDFEATURE_X2APIC);
             break;
-        case APIC_XAPIC:
+        case PDMAPICVERSION_APIC:
             CPUMSetGuestCpuIdFeature(pDevIns->Internal.s.pVMR0, CPUMCPUIDFEATURE_APIC);
             CPUMClearGuestCpuIdFeature(pDevIns->Internal.s.pVMR0, CPUMCPUIDFEATURE_X2APIC);
             break;
-        case APIC_X2APIC:
+        case PDMAPICVERSION_X2APIC:
             CPUMSetGuestCpuIdFeature(pDevIns->Internal.s.pVMR0, CPUMCPUIDFEATURE_X2APIC);
             CPUMSetGuestCpuIdFeature(pDevIns->Internal.s.pVMR0, CPUMCPUIDFEATURE_APIC);
             break;
         default:
-            AssertMsgFailed(("Unknown APIC version: %d\n", (int)version));
+            AssertMsgFailed(("Unknown APIC version: %d\n", (int)enmVersion));
     }
 }