Index: trunk/src/VBox/Devices/Audio/DevIchAc97.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevIchAc97.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/Audio/DevIchAc97.cpp	(revision 12977)
@@ -1716,5 +1716,5 @@
     /* szDeviceName */
     "ichac97",
-    /* szGCMod */
+    /* szRCMod */
     "",
     /* szR0Mod */
@@ -1751,4 +1751,12 @@
     NULL,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
Index: trunk/src/VBox/Devices/Audio/DevSB16.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevSB16.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/Audio/DevSB16.cpp	(revision 12977)
@@ -1848,5 +1848,5 @@
     /* szDeviceName */
     "sb16",
-    /* szGCMod */
+    /* szRCMod */
     "",
     /* szR0Mod */
@@ -1860,9 +1860,11 @@
     /* cMaxInstances */
     1,
-    /* bInstance */
+    /* cbInstance */
     sizeof(SB16State),
     /* pfnConstruct */
     sb16Construct,
     /* pfnDesctruct */
+    NULL,
+    /* pfnRelocate */
     NULL,
     /* pfnIOCtl */
@@ -1880,6 +1882,14 @@
     /* pfnDetach */
     NULL,
-    /* pfnQueryInterface. */
-    NULL
+    /* pfnQueryInterface */
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/Audio/audio_int.h
===================================================================
--- trunk/src/VBox/Devices/Audio/audio_int.h	(revision 12976)
+++ trunk/src/VBox/Devices/Audio/audio_int.h	(revision 12977)
@@ -263,7 +263,7 @@
 #ifndef VBOX
 static void GCC_ATTR dolog (const char *fmt, ...)
-#else 
+#else
 DECLINLINE(void) GCC_ATTR dolog (const char *fmt, ...) /* shuts up unused warnings. */
-#endif 
+#endif
 {
     va_list ap;
@@ -275,5 +275,5 @@
 
 #ifdef DEBUG
-static void GCC_ATTR ldebug (const char *fmt, ...)
+DECLINLINE(void) GCC_ATTR ldebug (const char *fmt, ...)
 {
     va_list ap;
@@ -293,5 +293,5 @@
 #else
 DECLINLINE(void) GCC_ATTR ldebug (const char *fmt, ...)  /* shuts up unused warnings. */
-#endif 
+#endif
 {
     (void) fmt;
Index: trunk/src/VBox/Devices/Audio/audiosniffer.c
===================================================================
--- trunk/src/VBox/Devices/Audio/audiosniffer.c	(revision 12976)
+++ trunk/src/VBox/Devices/Audio/audiosniffer.c	(revision 12977)
@@ -256,5 +256,5 @@
     /* szDeviceName */
     "AudioSniffer",
-    /* szGCMod */
+    /* szRCMod */
     "",
     /* szR0Mod */
@@ -293,4 +293,9 @@
     NULL,
     /* pfnInitComplete */
-    NULL
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    PDM_DEVREG_VERSION
 };
Index: trunk/src/VBox/Devices/Bus/DevPCI.cpp
===================================================================
--- trunk/src/VBox/Devices/Bus/DevPCI.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/Bus/DevPCI.cpp	(revision 12977)
@@ -1559,5 +1559,5 @@
     /* szDeviceName */
     "pci",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -1566,5 +1566,5 @@
     "i440FX PCI bridge and PIIX3 ISA bridge.",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32 | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32 | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_BUS_PCI | PDM_DEVREG_CLASS_BUS_ISA,
@@ -1596,5 +1596,12 @@
     NULL,
     /* pfnInitComplete */
-    NULL
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
+
 };
 #endif /* IN_RING3 */
Index: trunk/src/VBox/Devices/Graphics/DevVGA.cpp
===================================================================
--- trunk/src/VBox/Devices/Graphics/DevVGA.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/Graphics/DevVGA.cpp	(revision 12977)
@@ -4794,5 +4794,5 @@
                                               vgaR3LFBAccessHandler, pThis,
                                               g_DeviceVga.szR0Mod, "vgaR0LFBAccessHandler", pDevIns->pvInstanceDataR0,
-                                              g_DeviceVga.szGCMod, "vgaGCLFBAccessHandler", pDevIns->pvInstanceDataRC,
+                                              g_DeviceVga.szRCMod, "vgaGCLFBAccessHandler", pDevIns->pvInstanceDataRC,
                                               "VGA LFB");
             AssertRC(rc);
@@ -5224,8 +5224,8 @@
 
     /* The LBF access handler - error handling is better here than in the map function.  */
-    rc = PDMR3LdrGetSymbolRCLazy(pVM, pDevIns->pDevReg->szGCMod, "vgaGCLFBAccessHandler", &pThis->RCPtrLFBHandler);
+    rc = PDMR3LdrGetSymbolRCLazy(pVM, pDevIns->pDevReg->szRCMod, "vgaGCLFBAccessHandler", &pThis->RCPtrLFBHandler);
     if (RT_FAILURE(rc))
     {
-        AssertReleaseMsgFailed(("PDMR3LdrGetSymbolRC(, %s, \"vgaGCLFBAccessHandler\",) -> %Rrc\n", pDevIns->pDevReg->szGCMod, rc));
+        AssertReleaseMsgFailed(("PDMR3LdrGetSymbolRC(, %s, \"vgaGCLFBAccessHandler\",) -> %Rrc\n", pDevIns->pDevReg->szRCMod, rc));
         return rc;
     }
@@ -5845,5 +5845,5 @@
     /* szDeviceName */
     "vga",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -5852,5 +5852,5 @@
     "VGA Adaptor with VESA extensions.",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_GRAPHICS,
@@ -5882,5 +5882,11 @@
     NULL,
     /* pfnInitComplete */
-    NULL
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/Input/DevPS2.cpp
===================================================================
--- trunk/src/VBox/Devices/Input/DevPS2.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/Input/DevPS2.cpp	(revision 12977)
@@ -1743,5 +1743,5 @@
     /* szDeviceName */
     "pckbd",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -1752,5 +1752,5 @@
     "LUN #1 is the aux/mouse connector.",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_INPUT,
@@ -1780,5 +1780,13 @@
     kbdDetach,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/Network/DevPCNet.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/DevPCNet.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/Network/DevPCNet.cpp	(revision 12977)
@@ -1431,5 +1431,5 @@
                                           g_DevicePCNet.szR0Mod, "pcnetHandleRingWrite",
                                           pThis->pDevInsHC->pvInstanceDataHC,
-                                          g_DevicePCNet.szGCMod, "pcnetHandleRingWrite",
+                                          g_DevicePCNet.szRCMod, "pcnetHandleRingWrite",
                                           pThis->pDevInsHC->pvInstanceDataRC,
                                           "PCNet receive ring write access handler");
@@ -1470,5 +1470,5 @@
                                               g_DevicePCNet.szR0Mod, "pcnetHandleRingWrite",
                                               pThis->pDevInsHC->pvInstanceDataHC,
-                                              g_DevicePCNet.szGCMod, "pcnetHandleRingWrite",
+                                              g_DevicePCNet.szRCMod, "pcnetHandleRingWrite",
                                               pThis->pDevInsHC->pvInstanceDataRC,
                                               "PCNet transmit ring write access handler");
@@ -5017,5 +5017,5 @@
     /* szDeviceName */
     "pcnet",
-    /* szGCMod */
+    /* szRCMod */
 #ifdef PCNET_GC_ENABLED
     "VBoxDDGC.gc",
@@ -5029,5 +5029,5 @@
     /* fFlags */
 #ifdef PCNET_GC_ENABLED
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
 #else
     PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT,
@@ -5064,5 +5064,9 @@
     NULL,
     /* pfnPowerOff. */
-    pcnetPowerOff
+    pcnetPowerOff,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/PC/DevACPI.cpp
===================================================================
--- trunk/src/VBox/Devices/PC/DevACPI.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/PC/DevACPI.cpp	(revision 12977)
@@ -1953,5 +1953,5 @@
     /* szDeviceName */
     "acpi",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -1960,5 +1960,5 @@
     "Advanced Configuration and Power Interface",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_ACPI,
@@ -1988,5 +1988,13 @@
     NULL,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/PC/DevAPIC.cpp
===================================================================
--- trunk/src/VBox/Devices/PC/DevAPIC.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/PC/DevAPIC.cpp	(revision 12977)
@@ -2089,5 +2089,5 @@
     /* szDeviceName */
     "apic",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDD2GC.gc",
     /* szR0Mod */
@@ -2096,5 +2096,5 @@
     "Advanced Programmable Interrupt Controller (APIC) Device",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_PIC,
@@ -2124,5 +2124,13 @@
     NULL,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
@@ -2348,5 +2356,5 @@
     /* szDeviceName */
     "ioapic",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDD2GC.gc",
     /* szR0Mod */
@@ -2355,5 +2363,5 @@
     "I/O Advanced Programmable Interrupt Controller (IO-APIC) Device",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_PIC,
@@ -2387,5 +2395,9 @@
     NULL,
     /* pfnPowerOff */
-    NULL
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/PC/DevDMA.cpp
===================================================================
--- trunk/src/VBox/Devices/PC/DevDMA.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/PC/DevDMA.cpp	(revision 12977)
@@ -949,5 +949,5 @@
     /* szDeviceName */
     "8237A",
-    /* szGCMod */
+    /* szRCMod */
     "",
     /* szR0Mod */
@@ -988,5 +988,9 @@
     NULL,
     /* pfnPowerOff */
-    NULL
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 #endif /* VBOX */
Index: trunk/src/VBox/Devices/PC/DevPIC.cpp
===================================================================
--- trunk/src/VBox/Devices/PC/DevPIC.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/PC/DevPIC.cpp	(revision 12977)
@@ -1085,5 +1085,5 @@
     /* szDeviceName */
     "i8259",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -1092,5 +1092,5 @@
     "Intel 8259 Programmable Interrupt Controller (PIC) Device.",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_PIC,
@@ -1120,5 +1120,13 @@
     NULL,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/PC/DevPcArch.c
===================================================================
--- trunk/src/VBox/Devices/PC/DevPcArch.c	(revision 12976)
+++ trunk/src/VBox/Devices/PC/DevPcArch.c	(revision 12977)
@@ -278,5 +278,5 @@
     /* szDeviceName */
     "pcarch",
-    /* szGCMod */
+    /* szRCMod */
     "",
     /* szR0Mod */
@@ -315,5 +315,11 @@
     NULL,
     /* pfnInitComplete. */
-    NULL
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/PC/DevPcBios.cpp
===================================================================
--- trunk/src/VBox/Devices/PC/DevPcBios.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/PC/DevPcBios.cpp	(revision 12977)
@@ -1757,5 +1757,5 @@
     /* szDeviceName */
     "pcbios",
-    /* szGCMod */
+    /* szRCMod */
     "",
     /* szR0Mod */
@@ -1794,5 +1794,11 @@
     NULL,
     /* pfnInitComplete. */
-    pcbiosInitComplete
+    pcbiosInitComplete,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/PC/DevPit-i8254.cpp
===================================================================
--- trunk/src/VBox/Devices/PC/DevPit-i8254.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/PC/DevPit-i8254.cpp	(revision 12977)
@@ -1053,5 +1053,5 @@
     /* szDeviceName */
     "i8254",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -1060,5 +1060,5 @@
     "Intel 8254 Programmable Interval Timer (PIT) And Dummy Speaker Device",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_PIT,
@@ -1088,5 +1088,13 @@
     NULL,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/PC/DevRTC.cpp
===================================================================
--- trunk/src/VBox/Devices/PC/DevRTC.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/PC/DevRTC.cpp	(revision 12977)
@@ -931,5 +931,5 @@
     /* szDeviceName */
     "mc146818",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -938,5 +938,5 @@
     "Motorola MC146818 RTC/CMOS Device.",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_32_64 | PDM_DEVREG_FLAGS_PAE36 | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_RTC,
@@ -968,5 +968,11 @@
     NULL,
     /* pfnInitComplete */
-    rtcInitComplete
+    rtcInitComplete,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 #endif /* IN_RING3 */
Index: trunk/src/VBox/Devices/Parallel/DevParallel.cpp
===================================================================
--- trunk/src/VBox/Devices/Parallel/DevParallel.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/Parallel/DevParallel.cpp	(revision 12977)
@@ -872,5 +872,5 @@
     /* szDeviceName */
     "parallel",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -879,5 +879,5 @@
     "Parallel Communication Port",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_PARALLEL,
@@ -907,5 +907,13 @@
     NULL,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 #endif /* IN_RING3 */
Index: trunk/src/VBox/Devices/Serial/DevSerial.cpp
===================================================================
--- trunk/src/VBox/Devices/Serial/DevSerial.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/Serial/DevSerial.cpp	(revision 12977)
@@ -934,5 +934,5 @@
     /* szDeviceName */
     "serial",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -941,5 +941,5 @@
     "Serial Communication Port",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_SERIAL,
@@ -969,5 +969,13 @@
     NULL,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 #endif /* IN_RING3 */
Index: trunk/src/VBox/Devices/Storage/DevATA.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/DevATA.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/Storage/DevATA.cpp	(revision 12977)
@@ -5870,5 +5870,5 @@
     /* szDeviceName */
     "piix3ide",
-    /* szGCMod */
+    /* szRCMod */
     "VBoxDDGC.gc",
     /* szR0Mod */
@@ -5882,5 +5882,5 @@
     "  LUN #999 is the LED/Status connector.",
     /* fFlags */
-    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GC | PDM_DEVREG_FLAGS_R0,
+    PDM_DEVREG_FLAGS_HOST_BITS_DEFAULT | PDM_DEVREG_FLAGS_GUEST_BITS_DEFAULT | PDM_DEVREG_FLAGS_RC | PDM_DEVREG_FLAGS_R0,
     /* fClass */
     PDM_DEVREG_CLASS_STORAGE,
@@ -5914,5 +5914,9 @@
     NULL,
     /* pfnPowerOff */
-    ataPowerOff
+    ataPowerOff,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 #endif /* IN_RING3 */
Index: trunk/src/VBox/Devices/Storage/fdc.c
===================================================================
--- trunk/src/VBox/Devices/Storage/fdc.c	(revision 12976)
+++ trunk/src/VBox/Devices/Storage/fdc.c	(revision 12977)
@@ -2939,5 +2939,5 @@
     /* szDeviceName */
     "i82078",
-    /* szGCMod */
+    /* szRCMod */
     "",
     /* szR0Mod */
@@ -2974,5 +2974,13 @@
     fdcDetach,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 
Index: trunk/src/VBox/Devices/VMMDev/VBoxDev.cpp
===================================================================
--- trunk/src/VBox/Devices/VMMDev/VBoxDev.cpp	(revision 12976)
+++ trunk/src/VBox/Devices/VMMDev/VBoxDev.cpp	(revision 12977)
@@ -2457,5 +2457,5 @@
     /* szDeviceName */
     "VMMDev",
-    /* szGCMod */
+    /* szRCMod */
     "",
     /* szR0Mod */
@@ -2492,5 +2492,13 @@
     NULL,
     /* pfnQueryInterface. */
-    NULL
+    NULL,
+    /* pfnInitComplete */
+    NULL,
+    /* pfnPowerOff */
+    NULL,
+    /* pfnSoftReset */
+    NULL,
+    /* u32VersionEnd */
+    PDM_DEVREG_VERSION
 };
 #endif /* !VBOX_DEVICE_STRUCT_TESTCASE */