Index: /trunk/doc/VBox-doc.c
===================================================================
--- /trunk/doc/VBox-doc.c	(revision 13000)
+++ /trunk/doc/VBox-doc.c	(revision 13001)
@@ -27,22 +27,23 @@
  * @section pg_main_comp    Components
  *
- *  - VM / VMM / GVM / GVMM - Virtual Machine Monitor.
- *      - CFGM - Configuration Manager.
- *      - CPUM - CPU Monitor.
+ *  - VM / @ref pg_vmm "VMM" / GVM / @ref pg_gvmm "GVMM" - Virtual Machine
+ *    Monitor.
+ *      - @ref pg_cfgm
+ *      - @ref pg_cpum
  *      - CSAM - Guest OS Code Scanning and Analyis Manager.
- *      - DBGF - Debugging Facility.
+ *      - @ref pg_dbgf
  *          - DBGC - Debugger Console.
  *          - VBoxDbg - Debugger GUI (Qt).
  *      - DIS - Disassembler.
- *      - EM - Excution Monitor.
+ *      - @ref pg_em
  *      - HWACCM - Intel/AMD VM Hardware Support Manager.
  *      - REM - Recompiled Execution Monitor.
- *      - GMM - Global Memory Manager.
- *          - MM - Memory Monitor.
- *          - PGM - Page Monitor
- *          - SELM - Selector Monitor
- *      - IOM - Input / Output Monitor.
+ *      - @ref pg_gmm
+ *          - @ref pg_mm
+ *          - @ref pg_pgm
+ *          - @ref pg_selm
+ *      - @ref pg_iom
  *      - PATM - Dynamic Guest OS Patching Manager.
- *      - PDM  - Pluggable Device Manager.
+ *      - @ref pg_pdm
  *          - Devices / USB Devices, Drivers and their public interfaces.
  *          - Async I/O Completion API.
@@ -51,8 +52,8 @@
  *          - Queue API.
  *          - Thread API.
- *      - SSM - Save State Manager.
- *      - STAM - Statistics Manager.
- *      - TM - Time Monitor.
- *      - TRPM - Trap & Interrupt Monitor
+ *      - @ref pg_ssm
+ *      - @ref pg_stam
+ *      - @ref pg_tm
+ *      - @ref pg_trpm
  *  - Pluggable Components (via PDM).
  *      - DevPCArch - PC Architecture Device (chipset, legacy ++).
@@ -94,4 +95,5 @@
  *      - VBoxUSB - The USB support driver.
  *      - VBoxTAP - The Host Interface Networking driver.
+ *      - @ref pg_netflt
  *  - Host Services.
  *      - Shared Clipboard.
Index: /trunk/src/VBox/VMM/PGM.cpp
===================================================================
--- /trunk/src/VBox/VMM/PGM.cpp	(revision 13000)
+++ /trunk/src/VBox/VMM/PGM.cpp	(revision 13001)
@@ -23,4 +23,5 @@
 /** @page pg_pgm PGM - The Page Manager and Monitor
  *
+ * See also @ref pg_pgmPhys, @ref pg_pgm_pool.
  *
  *
Index: /trunk/src/VBox/VMM/SELM.cpp
===================================================================
--- /trunk/src/VBox/VMM/SELM.cpp	(revision 13000)
+++ /trunk/src/VBox/VMM/SELM.cpp	(revision 13001)
@@ -18,4 +18,11 @@
  * Clara, CA 95054 USA or visit http://www.sun.com if you need
  * additional information or have any questions.
+ */
+
+/** @page pg_selm   SELM - The Selector Manager
+ *
+ * Manages the hypervisor GDT entires, monitors and shadows the guest GDT, LDT
+ * and TSS. Only active in raw-mode.
+ *
  */
 
Index: /trunk/src/VBox/VMM/STAM.cpp
===================================================================
--- /trunk/src/VBox/VMM/STAM.cpp	(revision 13000)
+++ /trunk/src/VBox/VMM/STAM.cpp	(revision 13001)
@@ -18,4 +18,18 @@
  * Clara, CA 95054 USA or visit http://www.sun.com if you need
  * additional information or have any questions.
+ */
+
+/** @page pg_stam       STAM - The Statistics Manager
+ *
+ * The purpose for the statistics manager is to present the rest of the system
+ * with a somewhat uniform way of accessing VMM statistics. STAM sports a couple
+ * of different APIs for accessing them: STAMR3EnumU, STAMR3SnapshotU,
+ * STAMR3DumpU, STAMR3DumpToReleaseLogU. Main is exposing the XML based one,
+ * STAMR3SnapshotU.
+ *
+ * The rest of the VMM together with the devices and drivers registers their
+ * statistics with STAM giving them a name. The name is like hierarchical, the
+ * components separated by slashes ('/').
+ *
  */
 
Index: /trunk/src/VBox/VMM/VMMR0/GVMMR0.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR0/GVMMR0.cpp	(revision 13000)
+++ /trunk/src/VBox/VMM/VMMR0/GVMMR0.cpp	(revision 13001)
@@ -21,5 +21,5 @@
 
 
-/** @page pg_GVMM   GVMM - The Global VM Manager
+/** @page pg_gvmm   GVMM - The Global VM Manager
  *
  * The Global VM Manager lives in ring-0. It's main function at the moment